# Pantheon Ethereum Client
 [![Build Status](https://jenkins.pegasys.tech/job/Pantheon/job/master/badge/icon)](https://jenkins.pegasys.tech/job/Pantheon/job/master/)
 [![License](https://img.shields.io/badge/License-Apache%202.0-blue.svg)](https://github.com/PegasysEng/pantheon/blob/master/LICENSE)
 [ ![Download](https://api.bintray.com/packages/consensys/pegasys-repo/pantheon/images/download.svg) ](https://bintray.com/consensys/pegasys-repo/pantheon/_latestVersion)
 [![Gitter chat](https://badges.gitter.im/PegaSysEng/pantheon.png)](https://gitter.im/PegaSysEng/pantheon)

Pantheon is an Apache 2.0 licensed, MainNet compatible, Ethereum client written in Java.

## Pantheon Users

The process for installing and running Pantheon as a user is different to when developing. Some processes in our [user documentation](https://docs.pantheon.pegasys.tech/en/latest/) are different to those described in this Readme.

### Install and Run Pantheon

Installing and running Pantheon:
* [Installation]
* [Getting Started]

### Documentation

User and reference documentation available includes:
* [Command Line Options]
* [JSON-RPC API]
* [Private Network Quickstart]
* [Configuring Pantheon]
* [Using Pantheon]

## Pantheon Developers

* [Contribution Guidelines](CONTRIBUTING.md)
* [Coding Conventions](CODING-CONVENTIONS.md)
* [Command Line Interface (CLI) Style Guide](CLI-STYLE-GUIDE.md)
* [User Documentation] for running and using Pantheon

### Development
Instructions for how to get started with developing on the Pantheon codebase. Please also read the
[contribution guidelines](CONTRIBUTING.md) for more detail on how to submit a pull request (PR).

* [Checking Out and Building](docs/development/building.md)
* [Running Developer Builds](docs/development/running-developer-builds.md)
* [Code Coverage](docs/development/code-coverage.md)
* [Logging](docs/development/logging.md)

## Issues 

Pantheon issues are tracked in [Jira](https://pegasys1.atlassian.net/secure/Dashboard.jspa?selectPageId=10000) not GitHub. 
See our [contribution guidelines](CONTRIBUTING.md) for more detail on searching and creating issues. 

If you've commented on existing issue and have been waiting for a reply, feel free to ping us on [Gitter].  

[User Documentation]: https://docs.pantheon.pegasys.tech/en/latest/
[Installation]: https://docs.pantheon.pegasys.tech/en/latest/Installation/Overview/
[Getting Started]: https://docs.pantheon.pegasys.tech/en/latest/Getting-Started/Getting-Started/
[Private Network Quickstart]: https://docs.pantheon.pegasys.tech/en/latest/Tutorials/Private-Network-Quickstart/
[Command Line Options]: https://docs.pantheon.pegasys.tech/en/latest/Reference/Pantheon-CLI-Syntax/
[JSON-RPC API]: https://docs.pantheon.pegasys.tech/en/latest/Reference/Using-JSON-RPC-API/
[Configuring Pantheon]: https://docs.pantheon.pegasys.tech/en/latest/Configuring-Pantheon/NetworkID-And-ChainID/
[Using Pantheon]: https://docs.pantheon.pegasys.tech/en/latest/Using-Pantheon/Transactions/
[Gitter]: https://gitter.im/PegaSysEng/pantheon

## Release Notes

[Release Notes](CHANGELOG.md)
