/*
 * Copyright 2018 ConsenSys AG.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 */
package tech.pegasys.pantheon.tests.acceptance.dsl.pubsub;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;

public class JsonRpcSuccessEvent {

  private final String version;
  private final long id;
  private final String result;

  @JsonCreator
  public JsonRpcSuccessEvent(
      @JsonProperty("jsonrpc") final String version,
      @JsonProperty("id") final long id,
      @JsonProperty("result") final String result) {
    this.id = id;
    this.result = result;
    this.version = version;
  }

  public long getId() {
    return id;
  }

  public String getResult() {
    return result;
  }

  public String getVersion() {
    return version;
  }
}
