/*
 * Copyright 2018 ConsenSys AG.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 */
package tech.pegasys.pantheon.ethereum.jsonrpc.internal.results;

import com.fasterxml.jackson.annotation.JsonValue;

public class PendingTransactionsStatisticsResult {

  private final long maxSize;
  private final long localCount;
  private final long remoteCount;

  public PendingTransactionsStatisticsResult(
      final long maxSize, final long localCount, final long remoteCount) {
    this.maxSize = maxSize;
    this.localCount = localCount;
    this.remoteCount = remoteCount;
  }

  @JsonValue
  public long getMaxSize() {
    return maxSize;
  }

  @JsonValue
  public long getLocalCount() {
    return localCount;
  }

  @JsonValue
  public long getRemoteCount() {
    return remoteCount;
  }
}
